<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "scan_stats".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ScanStats".
 *
 * Columns in table "scan_stats" available as properties of the model,
 * followed by relations of table "scan_stats" available as properties of the model.
 *
 * @property integer $id
 * @property integer $scan_request_id
 * @property integer $op_score
 * @property integer $aggregate_accuracy
 * @property string $aggregate_rating
 * @property integer $total_reviews
 * @property integer $average_provider_accuracy
 * @property integer $average_provider_reviews
 * @property string $reviews_grade
 * @property integer $data_elements
 * @property string $date_added
 * @property integer $website_mobile
 * @property integer $completed_scans
 * @property integer $cnt_errors
 *
 * @property ScanRequest $scanRequest
 */
abstract class BaseScanStats extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'scan_stats';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ScanStats|ScanStats', $n);
    }

    public static function representingColumn()
    {
        return 'aggregate_rating';
    }

    public function rules()
    {
        return array(
            array('scan_request_id', 'required'),
            array('scan_request_id, op_score, aggregate_accuracy, total_reviews, average_provider_accuracy, average_provider_reviews, data_elements, website_mobile, completed_scans, cnt_errors', 'numerical', 'integerOnly' => true),
            array('aggregate_rating', 'length', 'max' => 3),
            array('reviews_grade', 'length', 'max' => 5),
            array('date_added', 'safe'),
            array('op_score, aggregate_accuracy, aggregate_rating, total_reviews, average_provider_accuracy, average_provider_reviews, reviews_grade, data_elements, date_added, website_mobile, completed_scans, cnt_errors', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, scan_request_id, op_score, aggregate_accuracy, aggregate_rating, total_reviews, average_provider_accuracy, average_provider_reviews, reviews_grade, data_elements, date_added, website_mobile, completed_scans, cnt_errors', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'scanRequest' => array(self::BELONGS_TO, 'ScanRequest', 'scan_request_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'scan_request_id' => null,
            'op_score' => Yii::t('app', 'Op Score'),
            'aggregate_accuracy' => Yii::t('app', 'Aggregate Accuracy'),
            'aggregate_rating' => Yii::t('app', 'Aggregate Rating'),
            'total_reviews' => Yii::t('app', 'Total Reviews'),
            'average_provider_accuracy' => Yii::t('app', 'Average Provider Accuracy'),
            'average_provider_reviews' => Yii::t('app', 'Average Provider Reviews'),
            'reviews_grade' => Yii::t('app', 'Reviews Grade'),
            'data_elements' => Yii::t('app', 'Data Elements'),
            'date_added' => Yii::t('app', 'Date Added'),
            'website_mobile' => Yii::t('app', 'Website Mobile'),
            'completed_scans' => Yii::t('app', 'Completed Scans'),
            'cnt_errors' => Yii::t('app', 'Cnt Errors'),
            'scanRequest' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('scan_request_id', $this->scan_request_id);
        $criteria->compare('op_score', $this->op_score);
        $criteria->compare('aggregate_accuracy', $this->aggregate_accuracy);
        $criteria->compare('aggregate_rating', $this->aggregate_rating, true);
        $criteria->compare('total_reviews', $this->total_reviews);
        $criteria->compare('average_provider_accuracy', $this->average_provider_accuracy);
        $criteria->compare('average_provider_reviews', $this->average_provider_reviews);
        $criteria->compare('reviews_grade', $this->reviews_grade, true);
        $criteria->compare('data_elements', $this->data_elements);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('website_mobile', $this->website_mobile);
        $criteria->compare('completed_scans', $this->completed_scans);
        $criteria->compare('cnt_errors', $this->cnt_errors);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
